import java.util.ArrayList;
import java.util.List;

public class RadixSort {

	public static void main(String[] args) {
		ArrayList<String> sample = new ArrayList<>();
		sample.add("AIA");
		sample.add("IPV2");
		sample.add("R2D2");
		sample.add("AI");
		
		radixSort(sample);
		
		for(String s : sample)
			System.out.print(s + " ");
	}
	
	static void radixSort(ArrayList<String> names) {
		List<String>[] b = new ArrayList[37];
		for(int bi = 0; bi < b.length; bi++) {
			b[bi] = new ArrayList<>();
		}
		
		for(int i = 3; i >= 0; i--) {
			
			for(String s : names) {			
				int bucket = getBucket(i, s);			
				b[bucket].add(s);
			}
			
			names.clear();
			for(int bi = 0; bi < b.length; bi++) {
				names.addAll(b[bi]);
				b[bi].clear();
			}
		}
	}
	
	public static int getBucket(int pos, String name) {
		int realPos = pos - (4 - name.length());
		
		if(realPos < 0)
			return mapChar('/');
		
		return mapChar(name.charAt(realPos));
	}
	
	private static int mapChar(char c) {
		if(c == '/')
			return 0;
		
		if(c >= '0' && c <= '9')
			return c - '0' + 1;
		
		if(c >= 'A' && c <= 'Z')
			return c - 'A' + 11;
		
		return -1;
	}
}
